/* CAT_IN.C  Input routines and utilities for CATALOG, with use of 'exact' */

#include "catalog.h"
#include "catvars.h"


/* -------------------- get book info from user ------------------------- */
enter_book()
{
  int left=18,top=5,right=70,bottom=9;
  char title[TSIZ],author[ASIZ],ident[ISIZ];
  static char lasttitle[TSIZ] = {0};
  BOOK entry;

  if (num_books) {
    window(1,1,80,25); textattr(std_attr);
    gotoxy(19,3);
    cprintf("Last: %s",lasttitle);
  }
a:
  title[0] = author[0] = ident[0] = '\0';
  box(left,top,right,bottom,norm_attr,2);
  if (num_books == MAXSIZ-1) {
    stdscrn();
    error_msg("catalog now full",31,7);
    return 0;
  }
  gotoxy(3,3);
  cprintf(" Title: ");
  gotoxy(3,4);
  cprintf("Author: ");
  gotoxy(3,5);
  cprintf("id code: ");
  gotoxy(11,3);
  if (Getstr(title,TSIZ-1) == -1)
    return 0;
  if (!title[0])
    return 0;
  if (!exact) {
    if (!clean_title(title)) {
      error_msg("Illegal title",27,7);
      goto a;
    }
  }
  gotoxy(11,4);
  if (Getstr(author,ASIZ-1) == -1)
    return 0;
  if (author[0])
    if (!exact) {
      if (!clean_name(author)) {
        error_msg("Illegal name",27,8);
        goto a;
      }
    }
  gotoxy(12,5);
  if (Getstr(ident,ISIZ-1) == -1)
    return 0;
  if(ident[0])
    if (!exact)
      clean_spaces(ident,ISIZ);
  strcpy(entry.author,author);
  strcpy(entry.title,title);
  strcpy(entry.ident,ident);
  insert(entry);
  strcpy(lasttitle,title);clrscr();
  return 1;
}

/* ---------------------- insert entry in array ----------------------- */
void
insert(BOOK entry)
{
  int i,m;

  for (i=num_books; i>0; i--) {
    if (cmp_books(catalog[indx[i-1]],entry) < 0)
      break;
  }
  m = i;
  for (i=num_books; i>m; i--)
    indx[i] = indx[i-1];
  indx[m] = num_books;
  catalog[indx[m]] = entry;
  num_books++;
  changed = 1;
  return;
}

cmp_books(BOOK book1,BOOK book2)
{
  if (strcmpi(book1.author,book2.author) < 0)
    return -1;
  if (strcmpi(book1.author,book2.author) == 0)
    return stricmp(book1.title,book2.title);
  return 1;
}

/* ---------------------- display or print items ------------------------- */
void
make_list(int n)
 {
   int start,end,dest,k;
   char start_ltr[2] = {0},end_ltr[2] = {0};
   char heading[36], ch;

   switch(n) {
     case 0:           /* authors */
a:
       k = get_start_end(0, &start, &end, start_ltr, end_ltr);
       if (k == -1)
         return;
       if (k == 0)
         goto a;
       if (start == 0 && end == num_books)
         strcpy(heading," All Authors ");
       else if (start_ltr[0] == end_ltr[0]) {
         strcpy(heading," Authors, first letter ");
         strcat(heading,start_ltr); strcat(heading," ");
        }
       else {
         strcpy(heading," Authors, from ");
         strcat(heading,start_ltr); strcat(heading," through ");
         strcat(heading,end_ltr); strcat(heading," ");
       }
       dest = get_destination();
       if (dest == -1)
         break;
       else if (dest == 0)
         list_authors(start,end,heading);
       else
         print_authors(start,end,heading);
       break;
     case 1:                  /* titles */
b:
       k = get_start_end(1, &start, &end, start_ltr, end_ltr);
       if (k == -1)
         return;
       if (k == 0)
         goto b;
       if (start == 0 && end == num_books)
         strcpy(heading," All Titles ");
       else if (start_ltr[0] == end_ltr[0]) {
        strcpy(heading," Titles starting with ");
         strcat(heading,end_ltr); strcat(heading," ");
        }
       else {
         strcpy(heading," Titles, from ");
         strcat(heading,start_ltr); strcat(heading," through ");
         strcat(heading,end_ltr); strcat(heading," ");
        }
       dest = get_destination();
       if (dest == -1)
         break;
       else if (dest == 0)
         list_titles(start,end,heading);
       else
         print_titles(start,end,heading);
       save_restore_indx(1);             /* restore author order */
       break;
     case 2:
c:
       k = get_start_end(0, &start, &end, start_ltr, end_ltr);
       if (k == -1)
         return;
       if (k == 0)
         goto c;
       if (start == 0 && end == num_books)
          strcpy(heading," All Entries ");
        else if (start_ltr[0] == end_ltr[0]) {
          strcpy(heading," Entries, authors starting with ");
          strcat(heading,end_ltr); strcat(heading," ");
        }
       else {
         strcpy(heading," Entries, from authors ");
         strcat(heading,start_ltr); strcat(heading," through ");
         strcat(heading,end_ltr); strcat(heading," ");
       }
       dest = get_destination();
       if (dest == -1)
         break;
       else if (dest == 0)
         list_catalog(start,end,heading);
       else
         print_catalog(start,end,heading);
    }
}

/* --------------------------------- */
get_destination()
{
  int left=33,top=9,right=48,bottom=10,border=1;
  int dest ,col0 = 4,row0 = 3;
  char *item[] = { " Screen  ",
                   " Printer ",
                     NULL};
  int ltr[] = {'s','p'};

  if (!mono) {
    norm_attr = BLACK+16*LIGHTGRAY, high_attr = BLACK+16*BROWN;
    tag_norm = RED+16*LIGHTGRAY, tag_high = BLACK+16*BROWN;
  }
  window(left-1,top-1,right+1,bottom+1);
  dest =  menu_select(left,top,right,bottom,border," SEND TO ",
             col0,row0-1,0,ltr,item);
  if (!mono) {
     norm_attr = WHITE+16*BLUE, high_attr = BLUE+16*LIGHTGRAY;
     tag_norm = YELLOW+16*BLUE, tag_high = YELLOW+16*LIGHTGRAY;
  }
  return dest;
}

/* --------------------------------- */
get_start_end(int n, int *start, int *end, char *start_ltr, char *end_ltr)
{
  char ch;
  int i;
  int left=33,top=9,right=48,bottom=10;

  box(left,top,right,bottom,high_attr,1);
  gotoxy(2,2); showcursor();
  start_ltr[0] = end_ltr[0] = '\0';
  cputs("Start letter: ");
  if (Getstr(start_ltr,1) == -1)
    return -1;
  if (!start_ltr[0])
    strcpy(start_ltr,"A");
  else
    strupr(start_ltr);
  gotoxy(2,3);
  cputs("End letter: ");
  if (Getstr(end_ltr,1) == -1)
    return -1;
  if (!end_ltr[0])
    strcpy(end_ltr,"Z");
  else
    strupr(end_ltr);
  if (end_ltr[0] < start_ltr[0]) {    /* swap if necessary */
    ch = start_ltr[0];
    start_ltr[0] = end_ltr[0];
    end_ltr[0] = ch;
  }
  if (n == 0) {
    if(start_ltr[0] == 'A')
      *start = 0;
    else {
      for (i=0; i<num_books; i++) {
        if (catalog[indx[i]].author[0] >= start_ltr[0])
          break;
      }
      *start = i;
    }
    if (end_ltr[0] == 'Z')
      *end = num_books;
    else {
      for (i=0; i<num_books; i++) {
        if (catalog[indx[i]].author[0] > end_ltr[0])
          break;
      }
      *end = i;
    }
    if (*start >= *end) {
      error_msg("No items in this range",left-1,bottom+2);
      return 0;
    }
  }
  else {
    save_restore_indx(0);            /* save current indx[] array */
    qsort(indx, num_books, sizeof(int), cmp_title);
    if (start_ltr[0] == 'A')
      *start = 0;
    else {
      for (i=0; i<num_books; i++) {
        if (toupper(catalog[indx[i]].title[0]) >= start_ltr[0])
          break;
      }
      *start = i;
    }
    if (end_ltr[0] == 'Z')
      *end = num_books;
    else {
      for (i=0; i<num_books; i++) {
        if (toupper(catalog[indx[i]].title[0]) > end_ltr[0])
          break;
      }
      *end = i;
    }
    if (*start >= *end) {
      error_msg("No items in this range",left-1,bottom+2);
      save_restore_indx(1);                      /* restore author order */
      return 0;
    }
  }
  return 1;
}

/* ------------------- check and correct entry -------------------------- */
void
modify()
{
  char s[TSIZ]={0},title[TSIZ],author[ASIZ],ident[ISIZ];
  BOOK entry;
  int left=14,top=5,right=63,bottom=14;
  int found[MAXSIZ],num_found;
  int i,m,temp,search;
  while(1) {
    stdscrn();
    box(left,top,right,bottom,31,2);
    gotoxy(22,1); cputs(" CHECK ");
    window(left,top,right,bottom);
    showcursor();
    while(1) {
      clrscr();
      gotoxy(2,1); cputs("Title: ");
      gotoxy(2,3); cputs("Author: ");
      gotoxy(2,5); cputs("id code: ");
      s[0] = '\0';
      gotoxy(2,2);
      if (Getstr(s,TSIZ-1) == -1)
        return;
      if (s[0]) {
        search = 0;
        break;
      }
      else {
        gotoxy(2,4);
        if (Getstr(s,ASIZ-1) == -1)
          return;
      }
      if (s[0]) {
        search = 1;
        break;
      }
      else {
        gotoxy(2,6);
        if (Getstr(s,ISIZ-1) == -1)
          return;
      }
      if (s[0]) {
        search = 2;
        break;
      }
      else
        return;
    }
    if (search == 0) {
      if (!exact) {
        if (!clean_title(s)) {
          error_msg("Illegal in title",left+1,top+2);
          continue;
        }
      }
      strupr(s);
      num_found = 0;
      for (i=0; i<num_books; i++) {
        if (instr(catalog[indx[i]].title,s) != 0)
          found[num_found++] = i;
      }
    }
    else if (search == 1) {
      if (!exact) {
        if (!clean_name(s)) {
          error_msg("Illegal in name",left+1,top+4);
          continue;
        }
      }
      strupr(s);
      num_found = 0;
      for (i=0; i<num_books; i++) {
        if (instr(catalog[indx[i]].author,s) != 0)
          found[num_found++] = i;
      }
    }
    else {
      if (!exact)
        clean_spaces(s);
      strupr(s);
      num_found = 0;
      for (i=0; i<num_books; i++) {
        if (strstr(catalog[indx[i]].ident,s) != 0) {
          found[num_found++] = i;
        }
      }
    }
    if (num_found > 1) {
      gotoxy(2,8); cputs("More than one match found.");
      gotoxy(2,9);
      cputs("Press D to display, else to continue");
      if (toupper(getch()) == 'D')
        display(found, num_found, " FOUND ");
      continue;
    }
    else {
      if (num_found == 0) {
        gotoxy(2,8); cputs("No match found.");
        getch();
        continue;
      }
    }
    m = found[0];
    strcpy(title,catalog[indx[m]].title);
    strcpy(author,catalog[indx[m]].author);
    strcpy(ident,catalog[indx[m]].ident);
    clrscr();
    showcursor();
    gotoxy(2,2);
    cputs(title);
    gotoxy(2,4);
    cputs(author);
    gotoxy(2,6);
    cputs(ident);
    gotoxy(2,1); cputs("Correct title if desired, else press Enter");
    gotoxy(2,2);
    if (Getstr(title,TSIZ-1) == -1)
      return;
    if (!exact)
      clean_title(title);
    gotoxy(2,3); cputs("Correct author if desired, else press Enter");
    gotoxy(2,4);
    if (Getstr(author,ASIZ-1) == -1)
      return;
    if (!exact)
      clean_name(author);
    gotoxy(2,5); cputs("Correct id code if desired, else press Enter");
    gotoxy(2,6);
    if (Getstr(ident,ISIZ-1) == -1)
      return;
    if (!exact)
      clean_spaces(ident);
    if (strcmp(catalog[indx[m]].author,author)
            || strcmp(catalog[indx[m]].title,title)
            || strcmp(catalog[indx[m]].ident,ident))
      changed = 1;
    if (changed) {
      strcpy(entry.author,author);
      strcpy(entry.title,title);
      strcpy(entry.ident,ident);
      if (m>0 && strcmp(author,catalog[indx[m-1]].author) <= 0) {
        while (m > 0 && cmp_books(entry,catalog[indx[m-1]]) < 0) {
          temp = indx[m];
          indx[m] = indx[m-1];
          indx[m-1] = temp;
          m--;
        }
      }
      else
      if (m<num_books-1 && strcmp(author,catalog[indx[m+1]].author) >= 0) {
        while (m<num_books-1 && cmp_books(entry,catalog[indx[m+1]]) > 0) {
          temp = indx[m];
          indx[m] = indx[m+1];
          indx[m+1] = temp;
          m++;
        }
      }
      catalog[indx[m]] = entry;
    }
  }
}

/* --------------------------------- */
save_restore_indx(int n)
{
  static int indx1[MAXSIZ];
  if (n == 0)
    memcpy(indx1,indx,num_books*sizeof(int));  /* save author order */
  else
    memcpy(indx,indx1,num_books*sizeof(int));  /* restore author order */
}

/* ------------------------ get data from file -------------------------- */
read_lines(char *filename)
{
  FILE *fp;
  int c=1, row=16, i=1;
  char s[81];
  BOOK entry;

  fp = fopen(filename,"r");
  if (fp == NULL) {
    error_msg("File not found",37,15);
    return -1;
  }
  gotoxy(2,2); cputs("                         ");
  gotoxy(2,2); cputs("Loading");
  window(1,1,80,25);
  hidecursor();
  textattr(std_attr);
  num_books = 0;
  while (1) {
    if (!getline(fp,s,ASIZ-1))
      break;
    if (s[0])
      if (!clean_name(s)) {
        box(27,17,53,17,error_attr,1);
        gotoxy(2,2); cprintf("Error in file, line %d",i);
        getch();
        textattr(std_attr);
        clrscr();
        return -1;
      }
    i++;
    strcpy(entry.author,s);
    if (!getline(fp,s,TSIZ-1) || s[0] == '\0') {
      box(27,17,53,17,error_attr,1);
      gotoxy(2,2); cprintf("Error in file, line %d",i);
      getch();
      textattr(std_attr);
      clrscr();
      return -1;
    }
    if (!clean_title(s)) {
      box(27,17,53,17,error_attr,1);
      gotoxy(2,2); cprintf("Error in file, line %d",i);
      getch();
      textattr(std_attr);
      clrscr();
      return -1;
    }
    i++;
    strcpy(entry.title,s);
    if (!getline(fp,s,ISIZ-1)) {
      box(27,17,53,17,error_attr,1);
      gotoxy(2,2); cprintf("Error in file, line %d",i);
      getch();
      textattr(std_attr);
      clrscr();
      return -1;
    }
    i++;
    clean_spaces(s);
    strcpy(entry.ident,s);
    insert(entry);
    if (num_books % 10 == 0) {
    gotoxy(c++,row);
    cputs(".");
    }
  }
  fclose(fp);
  return num_books;
}

read_lines_E(char *filename)
{
  FILE *fp;
  int c=1, row=16, i=1;
  char s[81];
  BOOK entry;

  fp = fopen(filename,"r");
  if (fp == NULL) {
    error_msg("File not found",37,15);
    return -1;
  }
  gotoxy(2,2); cputs("                         ");
  gotoxy(2,2); cputs("Loading");
  window(1,1,80,25);
  hidecursor();
  textattr(std_attr);
  num_books = 0;
  while (1) {
    if (!getline(fp,s,ASIZ-1))
      break;
    strcpy(entry.author,s);
    i++;
    if (!getline(fp,s,TSIZ-1) || s[0] == '\0') {
      box(27,17,53,17,error_attr,1);
      gotoxy(4,2); cprintf("Error in file, line %d",i);
      getch();
      textattr(std_attr);
      clrscr();
      return -1;
    }
    i++;
    strcpy(entry.title,s);
    if (!getline(fp,s,ISIZ-1)) {
      box(27,17,53,17,error_attr,1);
      gotoxy(2,2); cprintf("Error in file, line %d",i);
      getch();
      textattr(std_attr);
      clrscr();
      return -1;
    }
    i++;
    strcpy(entry.ident,s);
    insert(entry);
    if (num_books % 10 == 0) {
    gotoxy(c++,row);
    cputs(".");
    }
  }
  fclose(fp);
  return num_books;
}

/* --------------------------------- */
int
getline(FILE *fp, char *s, int n)
{
  char ch, *p=s;
  int cnt = 0;

  while (1) {
    ch = getc(fp);
    if (ch == '\n' || ch == EOF || cnt >= n)
      break;
    *p++ = ch;
    cnt++;
  }
  *p = '\0';
  if (ch != '\n')
    while (ch != '\n' && ch != EOF)
      ch = getc(fp);
  if (ch == EOF)
    return 0;
  else
    return 1;           /* return 1 if success, 0 if failure */
}

/* ----------------------- search catalog ------------------------------- */
void
search()
{
  char *item[] = {" Author ",
                  " Title  ",
                  " Code   ",
                    NULL };
  int ltr[] = {'a','t','c'};
  int left=33,top=5,right=47,bottom=7;
  int border=2;
  int col0 = 4,row0 = 2;
  char s[TSIZ],heading[62];
  int found[MAXSIZ],num_found,i,k;
  while (1) {
    stdscrn();
    gotoxy(32,25);
    cputs("Press F1 for help");
    s[0] = '\0';
    window(1,1,80,24);
    switch(menu_select(left,top,right,bottom,border," SEARCH ",
                      col0, row0, 0, ltr, item)) {
      case -1:
        return;
      case -2:
        help(4);
        continue;
      case 0:
a:
        k = get_search_string(s);
        if (k == -1)
          return;
        if (k == 0)
          continue;
        if (!exact) {
          if (!clean_name(s)) {
            error_msg("Illegal in name",13,12);
            goto a;
          }
        }
        strupr(s);
        num_found = 0;
        for (i=0; i<num_books; i++)
          if (instr(catalog[indx[i]].author,s) != 0)
            found[num_found++] = i;
        break;
      case 1:
        k = get_search_string(s);
        if (k == -1)
          return;
        if (k == 0)
          continue;
        if (!exact) {
          if (!clean_title(s)) {
            error_msg("Illegal in title",13,12);
            goto a;
          }
        }
        strupr(s);
        num_found = 0;
        for (i=0; i<num_books; i++) {
          if (instr(catalog[indx[i]].title,s) != 0)
            found[num_found++] = i;
        }
        break;
      case 2:
        k = get_search_string(s);
        if (k == -1)
          return;
        if (k == 0)
          continue;
        if (!exact)
          clean_spaces(s);
        num_found = 0;
        for (i=0; i<num_books; i++)
          if (strstr(catalog[indx[i]].ident,s) != NULL)
            found[num_found++] = i;
        break;
    }
    if (num_found == 0) {
      gotoxy(2,3);
      cputs("No match found");
      getch();
      continue;
    }
    display(found, num_found, " FOUND ");
  }
}

/* ------------------------------- */
get_search_string(char *s)
{
  int left=13,top=11,right=66,bottom=13;

  box(left,top,right,bottom,high_attr,1);
  gotoxy(2,2); showcursor(); s[0] = '\0';
  cputs("Search for: ");
  if (Getstr(s,40) == -1)
    return -1;;
  if (!s[0])
    return 0;
  return 1;
}

